// Example of C application that modifies a Grafix file
// =====================================================
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>


void majFich(int argc, char *argv[]) {
    
    // check of parameters
    int i ;
    printf("il y a %d argument(s) \n",argc) ;
    for (i=0 ; i < argc; i++)
       printf("argument %d = %s \n",i+1,argv[i]) ;
           assert(argc > 1) ;
    
    // name of the input file
    char * nfin ;
    nfin = (char *) malloc(sizeof(char)*100) ;
    nfin[0] = '\0';
    nfin= strcat(nfin,argv[2]);
    nfin= strcat(nfin,".gfx");
    printf("name of the input file = %s \n",nfin) ;
    // name of the output file
    char * nfout ;
    nfout = (char *) malloc(sizeof(char)*100) ;
    nfout[0] = '\0';
    nfout= strcat(nfout,argv[2]);
    nfout= strcat(nfout,".out.gfx");
    printf("name of the output file = %s \n",nfout) ;
    // open files
    FILE * fin, * fout ;
    fin = fopen(nfin,"r");
    assert (fin != NULL) ;
    fout = fopen(nfout,"w+");
    assert (fout != NULL) ;
    
    // read input file and write in output file
    // part 1 : since to find the string "MESSAGE:"
    int trouve = 0 ;
    char str[255] = "" ;
    rewind(fin);
    
    while ((!feof(fin)) && (!trouve)) {
       fscanf(fin,"%s",str) ;
       fprintf(fout,"%s",str) ;
       fprintf(fout,"%s","\n") ;
       printf("read and written line = %s \n",str) ;
       if (strcmp(str, "MESSAGE:") == 0) trouve = 1;
    }
    
    if (!trouve)
       // part 2-1 : introduce the MESSAGE:
       fprintf(fout,"%s","MESSAGE:\ncreation of a message\n.\n") ;
    else {
       // part 2-2 : update the MESSAGE:
       char * straux ;
       straux = (char *) malloc(sizeof(char)*500) ;
       straux[0] = '\0';
       printf("lines to write = %s \n",straux) ;
       straux = strcat(straux, "update of a message\n") ;
       printf("lignes a ecrire = %s \n",straux) ;
       fprintf(fout,"%s",straux) ;
       // read input file and write in output file
       // part 3 : since the end of input file
       while (!feof(fin)) {
          fscanf(fin,"%s",str) ;
          fprintf(fout,"%s",str) ;
          fprintf(fout,"%s","\n") ;
          printf("read and written line = %s \n",str) ;
       }
    }
    fclose(fin) ;
    fclose(fout) ;
}


int main (int argc, char *argv[]) {

    majFich(argc, argv) ;    
}

